//#include "stdafx.h"
#include "emmintrin.h"
#include "nmmintrin.h"


unsigned int bit_count_sse41(__m128i* block, __m128i* block_end)
{
    const unsigned mu1 = 0x55555555;
    const unsigned mu2 = 0x33333333;
    const unsigned mu3 = 0x0F0F0F0F;
    const unsigned mu4 = 0x01010101;

    // Loading masks
    __m128i m1 = _mm_set_epi32 (mu1, mu1, mu1, mu1);
    __m128i m2 = _mm_set_epi32 (mu2, mu2, mu2, mu2);
    __m128i m3 = _mm_set_epi32 (mu3, mu3, mu3, mu3);
    __m128i m4 = _mm_set_epi32 (mu4, mu4, mu4, mu4);
    __m128i mcnt = _mm_set_epi32 (mu4, mu4, mu4, mu4);
    mcnt = _mm_xor_si128(mcnt, mcnt); // cnt = 0

    while (block < block_end)
    {
        __m128i tmp1, tmp2, tmp3, tmp4;
        __m128i b = _mm_load_si128(block);

		// i = i - ((i >> 1) & 0x55555555);
        tmp1 = _mm_srli_epi32(b, 1);                    // tmp1 = (b >> 1 & 0x55555555)
        tmp1 = _mm_and_si128(tmp1, m1); 
        b    = _mm_sub_epi32(b, tmp1);               //  b = tmp1 + tmp2

		// i = (i & 0x33333333) + ((i >> 2) & 0x33333333);
        tmp1 = _mm_srli_epi32(b, 2);                    // (b >> 2 & 0x33333333)
        tmp1 = _mm_and_si128(tmp1, m2); 
        tmp2 = _mm_and_si128(b, m2);                    // (b & 0x33333333)
        b    = _mm_add_epi32(tmp1, tmp2);               // b = tmp1 + tmp2

		// i = (i + (i >> 4)) & 0x0f0f0f0f;
		tmp1 = _mm_srli_epi32(b, 4);                    // tmp1 = b >> 4
        b = _mm_add_epi32(b, tmp1);                     // b = b + (b >> 4)
        b = _mm_and_si128(b, m3);                       // & 0xF0F0F0F

		// i = (i * 0x01010101);
        tmp3 = _mm_mullo_epi32(b, m4);

        tmp3 = _mm_srli_epi32(tmp3, 24);

		mcnt = _mm_add_epi32(mcnt, tmp3);                  // mcnt += b

		++block;
    }
    unsigned int tcnt[4];
    _mm_storeu_si128((__m128i*)tcnt, mcnt);

    return tcnt[0] + tcnt[1] + tcnt[2] + tcnt[3];
}