#include <stdio.h>
#include <stdlib.h>
#include "time.h"

#include "func.h"

#define RUNS 500000

void main()
{
    clock_t s0, e0;
    double d0;

    unsigned int* input;
    input = (unsigned int*)(_aligned_malloc(1024*sizeof(int), 16));

    int cnt1;

    for (int i=0; i<1024; i++)
        *(input+i) = i;

    s0 = clock();
    for (int r=0; r<RUNS; r++)
    {
        cnt1 =  bit_count_for(input, (input+1024));
    }
    e0 = clock();
	d0 = double(e0 - s0)/CLOCKS_PER_SEC;
	printf("FOR:\t %4.4f  %d\n", d0, cnt1);

    s0 = clock();
    for (int r=0; r<RUNS; r++)
    {
        cnt1 =  bit_count_table((unsigned long long*)input, (unsigned long long*)(input+1024));
    }
    e0 = clock();
	d0 = double(e0 - s0)/CLOCKS_PER_SEC;
	printf("table:\t %4.4f  %d\n", d0, cnt1);

    s0 = clock();
    for (int r=0; r<RUNS; r++)
    {
        cnt1 =  bit_count_x86(input, (input+1024));
    }
    e0 = clock();
	d0 = double(e0 - s0)/CLOCKS_PER_SEC;
	printf("par:\t %4.4f  %d\n", d0, cnt1);

    s0 = clock();
    for (int r=0; r<RUNS; r++)
    {
        cnt1 =  bit_count_sse2((__m128i*)input, (__m128i*)(input+1024));
    }
    e0 = clock();
	d0 = double(e0 - s0)/CLOCKS_PER_SEC;
	printf("sse2:\t %4.4f  %d\n", d0, cnt1);

    s0 = clock();
    for (int r=0; r<RUNS; r++)
    {
        cnt1 =  bit_count_sse41((__m128i*)input, (__m128i*)(input+1024));
    }
    e0 = clock();
	d0 = double(e0 - s0)/CLOCKS_PER_SEC;
	printf("sse41:\t %4.4f  %d\n", d0, cnt1);

    s0 = clock();
    for (int r=0; r<RUNS; r++)
    {
        cnt1 =  bit_count_sse41_mod((__m128i*)input, (__m128i*)(input+1024));
    }
    e0 = clock();
	d0 = double(e0 - s0)/CLOCKS_PER_SEC;
	printf("sse4m:\t %4.4f  %d\n", d0, cnt1);

/*
    s0 = clock();
    for (int r=0; r<RUNS; r++)
    {
        cnt1 =  bit_count_sse42_x32((int*)input, (int*)(input+1024));
		//cnt1 =  bit_count_sse42_x64((__int64*)input, (__int64*)(input+1024));
    }
    e0 = clock();
	d0 = double(e0 - s0)/CLOCKS_PER_SEC;
	printf("sse42:\t %4.4f  %d\n", d0, cnt1);
*/
}